//+------------------------------------------------------------------+
//|                                     Pattern Recognition v1.0     |
//|          (complete rewrite and name change of pattern alert)     |
//+------------------------------------------------------------------+
//|                                    Full Pattern Recognition.mq4  |
//|                                Copyright  2005, Jason Robinson  |
//|                                  (jasonrobinsonuk,  jnrtrading)  |
//|                                     http://www.jnrtrading.co.uk  |
//|      This is still work in progress and needs LOTS of testing    |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Jason Robinson (jnrtrading)."
#property link      "http://www.jnrtrading.co.uk"


//----
extern bool Show_Alert = true;
//---- buffers
string PatternText[5000];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double Range, AvgRange;
   int  setalert;
   static datetime prevtime = 0;
   int shift;
   int shift1;
   int shift2;
   int shift3;
   string pattern, period;
   int setPattern = 0;
   int alert = 0;
   double O, O1, O2, C, C1, C2, L, L1, L2, H, H1, H2, SH_U, SH_L ,UBND, LBND;     
//----
   if(prevtime == Time[0]) 
     {
       return(0);
     }
   prevtime = Time[0];   
//----
   switch(Period()) 
     {
       case 1:     period = "M1";  break;
       case 5:     period = "M5";  break;
       case 15:    period = "M15"; break;
       case 30:    period = "M30"; break;      
       case 60:    period = "H1";  break;
       case 240:   period = "H4";  break;
       case 1440:  period = "D1";  break;
       case 10080: period = "W1";  break;
       case 43200: period = "MN";  break;
     }
//----
  
//----
   for(shift = 0; shift < Bars; shift++) 
     {
       setalert = 0;
       
       Range = 0;
       AvgRange = 0;
       shift1 = shift + 1;
       shift2 = shift + 2;
       shift3 = shift + 3;      
       O = Open[shift1];
       O1 = Open[shift2];
       O2 = Open[shift3];
       H = High[shift1];
       H1 = High[shift2];
       H2 = High[shift3];
       L = Low[shift1];
       L1 = Low[shift2];
       L2 = Low[shift3];
       C = Close[shift1];
       C1 = Close[shift2];
       C2 = Close[shift3];
       double BODY=C-O;
       UBND=MathMax(C,O);
       LBND=MathMin(C,O);  
       SH_U = H-UBND;
       SH_L = LBND-L;
           
       // Bearish Patterns   
       // Check for Bearish Engulfing pattern
       if((C1 > O1) && (O > C) && (O > C1) && (L < L1) && (C1<O)) 
        {
       
           if(setalert == 0 && Show_Alert == true) 
             {
               pattern = "Bearish Engulfing Pattern";
               setalert = 1;
             }
         }
  
       // CHECK FOR HAMMER
        
       if((SH_U< (SH_L/4)) && ((SH_L/3) >(MathAbs(BODY)))
       {
            if(setalert == 0 && Show_Alert == true) 
             {
               pattern = "Hammer";
               setalert = 1;
             }
        } 
    
          // CHECK FOR  Shooting
       if((SH_U >(4*SH_L)) && (SH_U >(3*MathAbs(BODY))))      
       {
            if(setalert == 0 && Show_Alert == true 
             {
               pattern = "Shooting";
               setalert = 1;
             }
         }
        
       // check for  Dark_Cloud_Cover pattern
       if((C1 > O1) && (((C1 + O1) / 2) > C) && (O > C) && (O > C1) && (C > O1) && 
       ((O - C) / (0.001 + (H - L)) > 0.6)) 
         {
               if(setalert == 0 && Show_Alert == true) 
             {
               pattern = "Dark Cloud Cover Pattern";
               setalert = 1;
             }
         }
        //    Check for Bullish Engulfing pattern
       if((O1 > C1) && (C > O) && (C > O1) && (H > H1)) 
         {   
            
           if(setalert == 0 && Show_Alert == true) 
             {
               pattern = "Bullish Engulfing Pattern";
               setalert = 1;
             }
         }  
          //   Check for Piercing Line pattern
       if((C1 < O1) && (((O1 + C1) / 2) < C) && (O < C) && (O < C1) && (C < O1) && 
          ((C - O) / (0.001 + (H - L)) > 0.6)) 
         {
            if(setalert == 0 && Show_Alert == true) 
             {
               pattern = "Piercing Line Pattern";
               setalert = 1;
             }
         }   
        if(setalert == 1) 
         {
               Alert(Symbol(), " ", period, " ", pattern);
                   setalert = 0;
         }
    
   return;
   }
  }
//+-----
  